"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.useIcon = void 0;

var _react = _interopRequireDefault(require("react"));

var _icon = _interopRequireDefault(require("../zalo-ui-kits/icon"));

var _badge = _interopRequireDefault(require("../components/badge"));

var useIcon = function useIcon(props) {
  if (props === void 0) {
    props = {};
  }

  var _props = props,
      icon = _props.icon,
      iconMaterial = _props.iconMaterial,
      iconZMP = _props.iconZMP,
      iconMd = _props.iconMd,
      iconIos = _props.iconIos,
      iconAurora = _props.iconAurora,
      iconColor = _props.iconColor,
      iconSize = _props.iconSize,
      iconBadge = _props.iconBadge,
      badgeColor = _props.badgeColor,
      iconBadgeColor = _props.iconBadgeColor;

  if (icon || iconMaterial || iconZMP || iconMd || iconIos || iconAurora) {
    return /*#__PURE__*/_react.default.createElement(_icon.default, {
      material: iconMaterial,
      zmp: iconZMP,
      icon: icon,
      md: iconMd,
      ios: iconIos,
      aurora: iconAurora,
      color: iconColor,
      size: iconSize
    }, (iconBadge || iconBadge === 0) && /*#__PURE__*/_react.default.createElement(_badge.default, {
      color: badgeColor || iconBadgeColor
    }, iconBadge));
  }

  return null;
};

exports.useIcon = useIcon;