"use strict";

exports.__esModule = true;
exports.watchProp = void 0;

var _react = require("react");

var _useIsomorphicLayoutEffect = require("./use-isomorphic-layout-effect");

var watchProp = function watchProp(value, callback) {
  var valueRef = (0, _react.useRef)(value);
  (0, _useIsomorphicLayoutEffect.useIsomorphicLayoutEffect)(function () {
    if (value !== valueRef.current && callback) {
      callback(value, valueRef.current);
    }

    valueRef.current = value;
  }, [value]);
};

exports.watchProp = watchProp;