"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _app = _interopRequireDefault(require("../components/app"));

var _routerConfig = _interopRequireDefault(require("../shared/router-config"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* dts-imports
  import { ZMPParameters } from 'zmp-core/types';
*/

/* dts-extends
  ZMPParameters
*/

/* dts-props
  className?: string;
  style?: React.CSSProperties;
  ref?: React.MutableRefObject<{el: HTMLElement | null}>;
  COLOR_PROPS
  CHILDREN_PROP
*/
var ZMPApp = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var navbar = props.navbar,
      routes = props.routes;
  var appRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return appRef.current;
  });
  var navbarConfigs = (0, _extends2.default)({}, navbar, {
    iosCenterTitle: navbar && navbar.iosCenterTitle || false
  });
  var appRoutes = (0, _routerConfig.default)() || routes;
  return /*#__PURE__*/_react.default.createElement(_app.default, (0, _extends2.default)({}, props, {
    ref: appRef,
    routes: appRoutes,
    navbar: navbarConfigs,
    iosTranslucentBars: false,
    iosTranslucentModals: false
  }));
});
ZMPApp.displayName = 'zmp-app';
var _default = ZMPApp;
exports.default = _default;