"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _utils = require("../shared/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* dts-props
  className?: string;
  style?: React.CSSProperties;
  title?: string;
  inset?: boolean;
  ref?: React.MutableRefObject<{el: HTMLElement | null}>;
  CHILDREN_PROP
*/
var Card = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var elRef = (0, _react.useRef)(null);
  var inset = props.inset,
      className = props.className,
      style = props.style,
      title = props.title;
  var classes = (0, _utils.classNames)(className, 'zmp-card', {
    'zmp-card-inset': inset
  });
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      el: ref.current
    };
  });
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: elRef,
    className: classes,
    style: style
  }, title && /*#__PURE__*/_react.default.createElement("div", {
    className: "zmp-card-title"
  }, title), /*#__PURE__*/_react.default.createElement("div", {
    className: "zmp-card-body"
  }, props.children));
});
Card.displayName = 'zmp-card';
var _default = Card;
exports.default = _default;