"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _icon = _interopRequireDefault(require("../components/icon"));

/* dts-imports
import { Icon } from 'zmp-core/types';
*/

/* dts-props
  id: string | number;
  className: string;
  style: React.CSSProperties;
  zmp? : Icon.IconZMP;
  tooltip? : string;
  tooltipTrigger? : string;
  size? : string | number;
  onClick? : (event?: any) => void;
  COLOR_PROPS
  ref?: React.MutableRefObject<{el: HTMLElement | null}>;
  CHILDREN_PROP
*/
var icons = {
  zi_add_member: 'zi-add-member',
  zi_add_member_solid: 'zi-add-member-solid',
  zi_add_user: 'zi-add-user',
  zi_add_user_solid: 'zi-add-user-solid',
  zi_admin: 'zi-admin',
  zi_create_group: 'zi-create-group',
  zi_create_group_solid: 'zi-create-group-solid',
  zi_group: 'zi-group',
  zi_group_solid: 'zi-group-solid',
  zi_members: 'zi-members',
  zi_members_solid: 'zi-members-solid',
  zi_stranger: 'zi-stranger',
  zi_stranger_solid: 'zi-stranger-solid',
  zi_switch_users: 'zi-switch-users',
  zi_switch_users_solid: 'zi-switch-users-solid',
  zi_user: 'zi-user',
  zi_user_check: 'zi-user-check',
  zi_user_circle: 'zi-user-circle',
  zi_user_circle_solid: 'zi-user-circle-solid',
  zi_user_search: 'zi-user-search',
  zi_user_search_solid: 'zi-user-search-solid',
  zi_user_settings: 'zi-user-settings',
  zi_user_settings_solid: 'zi-user-settings-solid',
  zi_user_solid: 'zi-user-solid',
  zi_add_photo: 'zi-add-photo',
  zi_camera: 'zi-camera',
  zi_gallery: 'zi-gallery',
  zi_link: 'zi-link',
  zi_livestream: 'zi-livestream',
  zi_pause: 'zi-pause',
  zi_pause_solid: 'zi-pause-solid',
  zi_photo: 'zi-photo',
  zi_photo_search: 'zi-photo-search',
  zi_photo_solid: 'zi-photo-solid',
  zi_play: 'zi-play',
  zi_play_solid: 'zi-play-solid',
  zi_add_story: 'zi-add-story',
  zi_ban: 'zi-ban',
  zi_bullet_solid: 'zi-bullet-solid',
  zi_check: 'zi-check',
  zi_check_circle: 'zi-check-circle',
  zi_check_circle_solid: 'zi-check-circle-solid',
  zi_close: 'zi-close',
  zi_close_circle: 'zi-close-circle',
  zi_close_circle_solid: 'zi-close-circle-solid',
  zi_copy: 'zi-copy',
  zi_delete: 'zi-delete',
  zi_drag_indicator_solid: 'zi-drag-indicator-solid',
  zi_filter: 'zi-filter',
  zi_filter_solid: 'zi-filter-solid',
  zi_home: 'zi-home',
  zi_leave: 'zi-leave',
  zi_leave_solid: 'zi-leave-solid',
  zi_list_1: 'zi-list-1',
  zi_list_2: 'zi-list-2',
  zi_minus_circle: 'zi-minus-circle',
  zi_minus_circle_solid: 'zi-minus-circle-solid',
  zi_more_diamond_solid: 'zi-more-diamond-solid',
  zi_more_grid: 'zi-more-grid',
  zi_more_grid_solid: 'zi-more-grid-solid',
  zi_more_horiz: 'zi-more-horiz',
  zi_more_horiz_solid: 'zi-more-horiz-solid',
  zi_more_vert: 'zi-more-vert',
  zi_plus: 'zi-plus',
  zi_plus_circle: 'zi-plus-circle',
  zi_plus_circle_solid: 'zi-plus-circle-solid',
  zi_radio_checked: 'zi-radio-checked',
  zi_radio_unchecked: 'zi-radio-unchecked',
  zi_save_to_collection: 'zi-save-to-collection',
  zi_search: 'zi-search',
  zi_setting: 'zi-setting',
  zi_tune: 'zi-tune',
  zi_arrow_down: 'zi-arrow-down',
  zi_arrow_left: 'zi-arrow-left',
  zi_arrow_right: 'zi-arrow-right',
  zi_arrow_up: 'zi-arrow-up',
  zi_auto: 'zi-auto',
  zi_auto_solid: 'zi-auto-solid',
  zi_backup_arrow_solid: 'zi-backup-arrow-solid',
  zi_chevron_double_down: 'zi-chevron-double-down',
  zi_chevron_double_up: 'zi-chevron-double-up',
  zi_chevron_down: 'zi-chevron-down',
  zi_chevron_left: 'zi-chevron-left',
  zi_chevron_left_header: 'zi-chevron-left-header',
  zi_chevron_right: 'zi-chevron-right',
  zi_chevron_up: 'zi-chevron-up',
  zi_download: 'zi-download',
  zi_download_solid: 'zi-download-solid',
  zi_reorder_solid: 'zi-reorder-solid',
  zi_reply: 'zi-reply',
  zi_reply_solid: 'zi-reply-solid',
  zi_retry: 'zi-retry',
  zi_retry_solid: 'zi-retry-solid',
  zi_share: 'zi-share',
  zi_share_external_1: 'zi-share-external-1',
  zi_share_external_2: 'zi-share-external-2',
  zi_share_solid: 'zi-share-solid',
  zi_unfold_less: 'zi-unfold-less',
  zi_unfold_more: 'zi-unfold-more',
  zi_upload: 'zi-upload',
  zi_at: 'zi-at',
  zi_bubble_multiselect: 'zi-bubble-multiselect',
  zi_call: 'zi-call',
  zi_call_solid: 'zi-call-solid',
  zi_chat: 'zi-chat',
  zi_chat_solid: 'zi-chat-solid',
  zi_grid_solid: 'zi-grid-solid',
  zi_location: 'zi-location',
  zi_location_solid: 'zi-location-solid',
  zi_mic: 'zi-mic',
  zi_quote: 'zi-quote',
  zi_quote_solid: 'zi-quote-solid',
  zi_recall: 'zi-recall',
  zi_send_solid: 'zi-send-solid',
  zi_user_window_solid: 'zi-user-window-solid',
  zi_video: 'zi-video',
  zi_video_group: 'zi-video-group',
  zi_video_solid: 'zi-video-solid',
  zi_wifi: 'zi-wifi',
  zi_wifi_off: 'zi-wifi-off',
  zi_backup_solid: 'zi-backup-solid',
  zi_backup_success_solid: 'zi-backup-success-solid',
  zi_backup_warning_solid: 'zi-backup-warning-solid',
  zi_bookmark: 'zi-bookmark',
  zi_bookmark_delete: 'zi-bookmark-delete',
  zi_favorite_list: 'zi-favorite-list',
  zi_heart: 'zi-heart',
  zi_heart_solid: 'zi-heart-solid',
  zi_pin: 'zi-pin',
  zi_pin_solid: 'zi-pin-solid',
  zi_star: 'zi-star',
  zi_star_solid: 'zi-star-solid',
  zi_unpin: 'zi-unpin',
  zi_calendar: 'zi-calendar',
  zi_calendar_solid: 'zi-calendar-solid',
  zi_clock_1: 'zi-clock-1',
  zi_clock_1_solid: 'zi-clock-1-solid',
  zi_clock_2: 'zi-clock-2',
  zi_clock_2_solid: 'zi-clock-2-solid',
  zi_memory: 'zi-memory',
  zi_reminder: 'zi-reminder',
  zi_reminder_delete: 'zi-reminder-delete',
  zi_reminder_solid: 'zi-reminder-solid',
  zi_edit: 'zi-edit',
  zi_edit_delete: 'zi-edit-delete',
  zi_edit_delete_solid: 'zi-edit-delete-solid',
  zi_edit_solid: 'zi-edit-solid',
  zi_edit_text: 'zi-edit-text',
  zi_edit_text_solid: 'zi-edit-text-solid',
  zi_post: 'zi-post',
  zi_exclamation: 'zi-exclamation',
  zi_help_circle: 'zi-help-circle',
  zi_info_circle: 'zi-info-circle',
  zi_info_circle_solid: 'zi-info-circle-solid',
  zi_warning: 'zi-warning',
  zi_warning_circle: 'zi-warning-circle',
  zi_warning_circle_solid: 'zi-warning-circle-solid',
  zi_warning_solid: 'zi-warning-solid',
  zi_file: 'zi-file',
  zi_inbox: 'zi-inbox',
  zi_note: 'zi-note',
  zi_note_delete: 'zi-note-delete',
  zi_pcline: 'zi-pcline',
  zi_poll: 'zi-poll',
  zi_poll_solid: 'zi-poll-solid',
  zi_qrline: 'zi-qrline',
  zi_truyen_file: 'zi-truyen-file',
  zi_wallpaper: 'zi-wallpaper',
  zi_hide: 'zi-hide',
  zi_key_solid: 'zi-key-solid',
  zi_lock: 'zi-lock',
  zi_lock_open_solid: 'zi-lock-open-solid',
  zi_lock_solid: 'zi-lock-solid',
  zi_notif: 'zi-notif',
  zi_notif_off: 'zi-notif-off',
  zi_notif_off_solid: 'zi-notif-off-solid',
  zi_notif_ring: 'zi-notif-ring',
  zi_shield_solid: 'zi-shield-solid',
  zi_unhide: 'zi-unhide',
  zi_unlock: 'zi-unlock',
  zi_unlock_solid: 'zi-unlock-solid'
};

var ZMPIcon = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var zmp = props.zmp,
      children = props.children,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["zmp", "children"]);

  var getIcon = function getIcon(iconStr) {
    if (typeof iconStr === 'string') {
      var iconKey = iconStr.replace(/-/g, '_');
      var _iconContent = icons[iconKey];
      return _iconContent || null;
    }

    return null;
  };

  var iconContent = getIcon(zmp || children);
  return /*#__PURE__*/_react.default.createElement(_icon.default, (0, _extends2.default)({}, rest, {
    zmp: iconContent,
    ref: ref
  }));
});

ZMPIcon.displayName = 'zmp-icon';
var _default = ZMPIcon;
exports.default = _default;