
import * as React from 'react';

import { Icon } from 'zmp-core/types';


interface ButtonProps {
  slot?: string;
  id?: string | number;
  className?: string;
  style?: React.CSSProperties;
  text ?: string;
  tabLink ?: boolean | string;
  tabLinkActive ?: boolean;
  type ?: string;
  href ?: string | boolean;
  target ?: string;
  fill ?: boolean;
  large ?: boolean;
  small ?: boolean;
  active ?: boolean;
  disabled ?: boolean;
  tooltip ?: string;
  tooltipTrigger ?: string;
  preloader?: boolean;
  preloaderSize?: number | string;
  preloaderColor?: string;
  loading?: boolean;
  onClick ?: (event?: any) => void;
  typeName?: 'primary' | 'secondary' | 'destructive' | 'tertiary' | 'ghost';
  ref?: React.MutableRefObject<{el: HTMLElement | null}>;
  responsive?: boolean;
  color?: string;
  colorTheme?: string;
  textColor?: string;
  bgColor?: string;
  borderColor?: string;
  rippleColor?: string;
  themeDark?: boolean;
  icon?: string;
  iconMaterial?: string;
  iconZMP?: Icon.IconZMP;
  iconIos?: string;
  iconMd?: string;
  iconAurora?: string;
  iconColor?: string;
  iconSize?: string | number;
  searchbarEnable?: boolean | string;
  searchbarDisable?: boolean | string;
  searchbarClear?: boolean | string;
  searchbarToggle?: boolean | string;
  sheetOpen?: boolean | string;
  sheetClose?: boolean | string;
  sortableEnable?: boolean | string;
  sortableDisable?: boolean | string;
  sortableToggle?: boolean | string;
  children?: React.ReactNode;
}
declare const Button: React.FunctionComponent<ButtonProps>;

export default Button;
  