
import * as React from 'react';

import { SmartSelect } from 'zmp-core/types';


interface ListItemProps {
  slot?: string;
  id?: string | number;
  className?: string;
  style?: React.CSSProperties;
  title ?: string | number;
  text ?: string | number;
  media ?: string;
  subtitle ?: string | number;
  description ?: string | number;
  tooltip ?: string;
  tooltipTrigger ?: string;
  link ?: boolean | string;
  tabLink ?: boolean | string;
  tabLinkActive ?: boolean;
  selected?: boolean;
  after ?: string | number;
  badge ?: string | number;
  badgeColor ?: string;
  mediaItem ?: boolean;
  mediaList ?: boolean;
  divider ?: boolean;
  groupTitle ?: boolean;
  swipeout ?: boolean;
  swipeoutOpened ?: boolean;
  sortable ?: boolean;
  sortableOpposite ?: boolean;
  accordionItem ?: boolean;
  accordionItemOpened ?: boolean;
  smartSelect ?: boolean;
  smartSelectParams ?: SmartSelect.Parameters;
  noChevron ?: boolean;
  chevronCenter ?: boolean;
  checkbox ?: boolean;
  radio ?: boolean;
  radioIcon ?: string;
  checked ?: boolean;
  defaultChecked ?: boolean;
  indeterminate ?: boolean;
  name ?: string;
  value ?: string | number | Array<any>;
  readonly ?: boolean;
  required ?: boolean;
  disabled ?: boolean;
  virtualListIndex ?: number;
  color?: string;
  colorTheme?: string;
  textColor?: string;
  bgColor?: string;
  borderColor?: string;
  rippleColor?: string;
  themeDark?: boolean;
  back?: boolean;
  force?: boolean;
  animate?: boolean;
  ignoreCache?: boolean;
  reloadCurrent?: boolean;
  reloadAll?: boolean;
  reloadPrevious?: boolean;
  reloadDetail?: boolean;
  routeTabId?: string;
  view?: string;
  routeProps?: any;
  preventRouter?: boolean;
  transition?: string;
  searchbarEnable?: boolean | string;
  searchbarDisable?: boolean | string;
  searchbarClear?: boolean | string;
  searchbarToggle?: boolean | string;
  sheetOpen?: boolean | string;
  sheetClose?: boolean | string;
  sortableEnable?: boolean | string;
  sortableDisable?: boolean | string;
  sortableToggle?: boolean | string;
  onClick ?: (event?: any) => void;
  onTapHold?: (...args: any[]) => void;
  onSwipeoutOverswipeEnter ?: (...args: any[]) => void;
  onSwipeoutOverswipeExit ?: (...args: any[]) => void;
  onSwipeoutDeleted ?: (...args: any[]) => void;
  onSwipeoutDelete ?: (...args: any[]) => void;
  onSwipeoutClose ?: (...args: any[]) => void;
  onSwipeoutClosed ?: (...args: any[]) => void;
  onSwipeoutOpen ?: (...args: any[]) => void;
  onSwipeoutOpened ?: (...args: any[]) => void;
  onSwipeout ?: (progress?: any) => void;
  onAccordionBeforeClose ?: (prevent?: any) => void;
  onAccordionClose ?: (...args: any[]) => void;
  onAccordionClosed ?: (...args: any[]) => void;
  onAccordionBeforeOpen ?: (prevent?: any) => void;
  onAccordionOpen ?: (...args: any[]) => void;
  onAccordionOpened ?: (...args: any[]) => void;
  onChange ?: (event?: any) => void;
  ref?: React.MutableRefObject<{el: HTMLElement | null;>;
  children?: React.ReactNode;
}
declare const ListItem: React.FunctionComponent<ListItemProps>;

export default ListItem;
  