
import * as React from 'react';

  import { View, Router } from 'zmp-core/types';


interface ViewProps {
  slot?: string;
  id?: string | number;
  className?: string;
  style?: React.CSSProperties;
  tab ?: boolean;
  tabActive ?: boolean;
  name ?: string;
  router ?: boolean;
  linksView ?: Object | string;
  url ?: string;
  main ?: boolean;
  stackPages ?: boolean;
  xhrCache ?: boolean;
  xhrCacheIgnore ?: Array<any>;
  xhrCacheIgnoreGetParameters ?: boolean;
  xhrCacheDuration ?: number;
  preloadPreviousPage ?: boolean;
  allowDuplicateUrls ?: boolean;
  reloadPages ?: boolean;
  reloadDetail ?: boolean;
  masterDetailResizable ?: boolean;
  masterDetailBreakpoint ?: number;
  removeElements ?: boolean;
  removeElementsWithTimeout ?: boolean;
  removeElementsTimeout ?: number;
  restoreScrollTopOnBack ?: boolean;
  loadInitialPage ?: boolean;
  iosSwipeBack ?: boolean;
  iosSwipeBackAnimateShadow ?: boolean;
  iosSwipeBackAnimateOpacity ?: boolean;
  iosSwipeBackActiveArea ?: number;
  iosSwipeBackThreshold ?: number;
  mdSwipeBack ?: boolean;
  mdSwipeBackAnimateShadow ?: boolean;
  mdSwipeBackAnimateOpacity ?: boolean;
  mdSwipeBackActiveArea ?: number;
  mdSwipeBackThreshold ?: number;
  auroraSwipeBack ?: boolean;
  auroraSwipeBackAnimateShadow ?: boolean;
  auroraSwipeBackAnimateOpacity ?: boolean;
  auroraSwipeBackActiveArea ?: number;
  auroraSwipeBackThreshold ?: number;
  browserHistory ?: boolean;
  browserHistoryRoot ?: string;
  browserHistoryAnimate ?: boolean;
  browserHistoryAnimateOnLoad ?: boolean;
  browserHistorySeparator ?: string;
  browserHistoryOnLoad ?: boolean;
  browserHistoryInitialMatch?: boolean;
  animate ?: boolean;
  transition ?: string;
  iosDynamicNavbar ?: boolean;
  iosAnimateNavbarBackIcon ?: boolean;
  materialPageLoadDelay ?: number;
  passRouteQueryToRequest ?: boolean;
  passRouteParamsToRequest ?: boolean;
  routesBeforeEnter ?: Function | Array<any>;
  routesBeforeLeave ?: Function | Array<any>;
  init ?: boolean;
  initRouterOnTabShow?: boolean;
  color?: string;
  colorTheme?: string;
  textColor?: string;
  bgColor?: string;
  borderColor?: string;
  rippleColor?: string;
  themeDark?: boolean;
  onViewInit ?: (view?: View.View) => void;
  onViewResize ?: (width?: number) => void;
  onSwipeBackMove ?: (swipeBackData?: Router.SwipeBackData) => void;
  onSwipeBackBeforeChange ?: (swipeBackData?: Router.SwipeBackData) => void;
  onSwipeBackAfterChange ?: (swipeBackData?: Router.SwipeBackData) => void;
  onSwipeBackBeforeReset ?: (swipeBackData?: Router.SwipeBackData) => void;
  onSwipeBackAfterReset ?: (swipeBackData?: Router.SwipeBackData) => void;
  onTabShow ?: (el?: HTMLElement) => void;
  onTabHide ?: (el?: HTMLElement) => void;
  ref?: React.MutableRefObject<{el: HTMLElement | null; zmpView: () => View.View}>;
  routesAdd?: Router.RouteParameters[];
  children?: React.ReactNode;
}
declare const View: React.FunctionComponent<ViewProps>;

export default View;
  