import _extends from "@babel/runtime/helpers/extends";
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import { classNames, getExtraAttrs } from '../shared/utils';
import { colorClasses } from '../shared/mixins';

var AccordionToggle = /*#__PURE__*/forwardRef(function (props, ref) {
  var className = props.className,
      id = props.id,
      style = props.style,
      children = props.children;
  var elRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      el: elRef.current
    };
  });
  var extraAttrs = getExtraAttrs(props);
  var classes = classNames(className, 'accordion-item-toggle', colorClasses(props));
  return /*#__PURE__*/React.createElement("div", _extends({
    id: id,
    style: style,
    className: classes
  }, extraAttrs, {
    ref: elRef
  }), children);
});
AccordionToggle.displayName = 'zmp-accordion-toggle';
export default AccordionToggle;