import _extends from "@babel/runtime/helpers/extends";
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import NavTitle from '../components/nav-title';
import { classNames } from '../shared/utils';
/* dts-props
  id?: string | number;
  className?: string;
  style?: React.CSSProperties;
  title? : string;
  subtitle? : string;
  sliding? : boolean;
  COLOR_PROPS
  ref?: React.MutableRefObject<{el: HTMLElement | null}>;
  CHILDREN_PROP
*/

var ZMPNavTitle = /*#__PURE__*/forwardRef(function (props, ref) {
  var subtitle = props.subtitle,
      className = props.className;
  var elRef = useRef(null);
  useImperativeHandle(ref, function () {
    return elRef.current;
  });
  var classes = className;

  if (subtitle) {
    classes = classNames(className, 'title-with-subtitle');
  }

  return /*#__PURE__*/React.createElement(NavTitle, _extends({
    ref: elRef
  }, props, {
    className: classes
  }));
});
ZMPNavTitle.displayName = 'zmp-nav-title';
export default ZMPNavTitle;