import ZMP, { ZMPPlugin } from 'zmp-core/types';
import { Store } from 'zmp-core/types';

import ActionsButton from './components/actions-button';
import ActionsGroup from './components/actions-group';
import ActionsLabel from './components/actions-label';
import Actions from './components/actions';
import App from './components/app';
import AvatarGroup from './components/avatar-group';
import Avatar from './components/avatar';
import Box from './components/box';
import Button from './components/button';
import Card from './components/card';
import Checkbox from './components/checkbox';
import Col from './components/col';
import DatePicker from './components/date-picker';
import FabBackdrop from './components/fab-backdrop';
import FabButton from './components/fab-button';
import FabButtons from './components/fab-buttons';
import Fab from './components/fab';
import GridItem from './components/grid-item';
import Grid from './components/grid';
import Icon from './components/icon';
import InputInfo from './components/input-info';
import Input from './components/input';
import Link from './components/link';
import ListInput from './components/list-input';
import ListItem from './components/list-item';
import List from './components/list';
import NavLeft from './components/nav-left';
import NavRight from './components/nav-right';
import NavTitleLarge from './components/nav-title-large';
import NavTitle from './components/nav-title';
import Navbar from './components/navbar';
import Page from './components/page';
import Picker from './components/picker';
import Preloader from './components/preloader';
import Progressbar from './components/progressbar';
import Radio from './components/radio';
import Range from './components/range';
import Row from './components/row';
import Searchbar from './components/searchbar';
import Sheet from './components/sheet';
import SkeletonAvatar from './components/skeleton-avatar';
import SkeletonBlock from './components/skeleton-block';
import SkeletonImage from './components/skeleton-image';
import SkeletonText from './components/skeleton-text';
import SwiperSlide from './components/swiper-slide';
import Swiper from './components/swiper';
import TabView from './components/tab-view';
import Tab from './components/tab';
import Tabbar from './components/tabbar';
import Tabs from './components/tabs';
import Text from './components/text';
import Title from './components/title';
import ToastPreloader from './components/toast-preloader';
import Toggle from './components/toggle';
import View from './components/view';

export interface ZMPTheme {
  ios: boolean;
  md: boolean;
  aurora: boolean;
}

/** Object with boolean properties with information about currently used theme (iOS, MD or Aurora) */
declare const theme: ZMPTheme;

/** Main ZMP's initialized instance. It allows you to use any of ZMP APIs */
declare const zmp: ZMP;

/** Callback function that will be executed when ZMP fully intialized. Useful to use in components when you need to access ZMP API and to be sure it is ready. So it is safe to put all ZMP related logic into this callback. As an argument it receives initialized ZMP instance */
declare const zmpready: (callback: (zmp: ZMP) => void) => void;

interface useStore {
  (store: Store, getter: string): any;
  (getter: string): any;
}

declare const useStore: useStore;

declare const ZMPReact: ZMPPlugin;

export { ActionsButton, ActionsGroup, ActionsLabel, Actions, App, AvatarGroup, Avatar, Box, Button, Card, Checkbox, Col, DatePicker, FabBackdrop, FabButton, FabButtons, Fab, GridItem, Grid, Icon, InputInfo, Input, Link, ListInput, ListItem, List, NavLeft, NavRight, NavTitleLarge, NavTitle, Navbar, Page, Picker, Preloader, Progressbar, Radio, Range, Row, Searchbar, Sheet, SkeletonAvatar, SkeletonBlock, SkeletonImage, SkeletonText, SwiperSlide, Swiper, TabView, Tab, Tabbar, Tabs, Text, Title, ToastPreloader, Toggle, View }
export { zmp, zmpready, theme, useStore };
export default ZMPReact;
